Hooks:PostHook( WeaponFactoryTweakData, "init", "Contrac308VariousModInit", function(self)
	
	self.parts.wpn_fps_snp_tti_ns_hex.forbids = { "wpn_fps_snp_tti_gasblock" }
	
	--Magazine RoF changes
	self.parts.wpn_fps_snp_tti_m_steel.override_weapon = {
		CLIP_AMMO_MAX = 21,
		AMMO_MAX = 41,
		fire_mode_data = { 
			fire_rate = 60 / 300
		}
        -- fire_mode_data = { --value for override_weapon_multiply
			-- fire_rate = 1 / 2
		-- }
    }
	
	
	--Gasblock position override
	self.parts.wpn_fps_snp_tti_fg_m16rail.override = {
		wpn_fps_snp_tti_gasblock = { a_obj = "a_gasb_m16rail" }
	}
	self.parts.wpn_fps_snp_tti_fg_m16viet.override = {
		wpn_fps_snp_tti_gasblock = { a_obj = "a_gasb_m16viet" }
	}
	
	
	--Gadget Position override
	local gadget_list = {"wpn_fps_upg_fl_ass_smg_sho_peqbox","wpn_fps_upg_fl_ass_smg_sho_surefire","wpn_fps_upg_fl_ass_peq15","wpn_fps_upg_fl_ass_laser","wpn_fps_upg_fl_ass_utg"}		
	for _, gadget_id in pairs(gadget_list) do
		self.parts.wpn_fps_snp_tti_fg_composite.override[gadget_id] = { a_obj = "a_fl_composite" }
		self.parts.wpn_fps_snp_tti_fg_rail.override[gadget_id] = { a_obj = "a_fl_rail" }
	end
	
	
	--Optic Position adjustment
	self.parts.wpn_fps_snp_tti_fg_rail.stance_mod = { 
		wpn_fps_snp_tti = { translation = Vector3(0, 0, -1.75) }
	}
	for _, optic_id in ipairs(self.wpn_fps_snp_tti.uses_parts) do
		if ( self.parts[optic_id].type == "sight" ) then
			self.parts.wpn_fps_snp_tti_fg_rail.override[optic_id] = { a_obj = "a_o_rail" }
		end
	end
	for _, gadget_optic_id in ipairs(self.wpn_fps_snp_tti.uses_parts) do
		if self.parts[gadget_optic_id].type == "gadget" and self.parts[gadget_optic_id].sub_type == "second_sight" then
			self.parts.wpn_fps_snp_tti_fg_rail.override[gadget_optic_id] = { a_obj = "a_o_rail" }
		end
	end

	
	
	-----------------------------------------------------------------------------------------------------------------------------------------------------------------
	--Compatibility -----------------------------------------------------------------------------------------------------------------------------------------------------------------
	-----------------------------------------------------------------------------------------------------------------------------------------------------------------
	if BeardLib.Utils:FindMod("Vanilla Styled Weapon Mods") then
		self.parts.wpn_fps_snp_tti_b_long.override.wpn_fps_snp_tti_ns_cylinder = { unit = "units/mods/weapons/wpn_fps_snp_tti_pts/wpn_fps_snp_tti_ovrd_cylinder" }
	end
	
	--[[
	if BeardLib.Utils:FindMod("Iron Sights Pack") then
		local ironsight_front = {
			"wpn_fps_upg_o_var_dd_a1_front",
			"wpn_fps_upg_o_var_kac_front",
			"wpn_fps_upg_o_var_m4flipup_front",
			"wpn_fps_upg_o_var_mbus_front",
			"wpn_fps_upg_o_var_scorpionevo_front",
			"wpn_fps_upg_o_var_troy_front",
			"wpn_fps_upg_o_var_troym4_front"
		}	
		for _, ironsight_id in pairs(ironsight_front) do
			self.parts.wpn_fps_snp_tti_fg_composite.override[ironsight_id] = { a_obj = "a_of_composite" }
			self.parts.wpn_fps_snp_tti_fg_rail.override[ironsight_id] = { a_obj = "a_of_rail" }
		end
		
		local ironsight_rear = {
			"wpn_fps_upg_o_var_dd_a1_rear",
			"wpn_fps_upg_o_var_kac_rear",
			"wpn_fps_upg_o_var_m4flipup_rear",
			"wpn_fps_upg_o_var_mbus_rear",
			"wpn_fps_upg_o_var_scorpionevo_rear",
			"wpn_fps_upg_o_var_troy_rear",
			"wpn_fps_upg_o_var_troym4_rear"
		}
		for _, ironsight_id in pairs(ironsight_rear) do
			self.parts.wpn_fps_snp_tti_fg_rail.override[ironsight_id] = { a_obj = "a_or_rail" }
		end
	end
	]]--

end )